communication/urls.py
from django.urls import path
from .views import MessagesListView, MessagesDetailView, MessagesSendView
app_name = 'communication'

urlpatterns = [
    path('list/', MessagesListView.as_view(), name='messages_list'),
    path('detail/<int:user_id>/', MessagesDetailView.as_view(), name='messages_detail'),
    path('detail/<int:user_id>/send', MessagesSendView.as_view(), name='messages_send'),
]

main/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
urlpatterns = [
    path('admin/', admin.site.urls),
    path('user/', include('users.urls')),
    path('communication/', include('communication.urls')),
    path('', include('items.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

communication/models.py
from django.db import models
from django.conf import settings
from django.utils.translation import gettext_lazy as _


class UserComments(models.Model):
    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, null=True,
                             related_name='comments_to_me', verbose_name=_("User"))
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True,
                              related_name='comments_by_me', verbose_name=_("Owner"))
    parent = models.ForeignKey('self', on_delete=models.CASCADE, related_name='replies', blank=True, null=True,
                               verbose_name=_("Parent"))
    comment = models.TextField(max_length=140, verbose_name=_("Comment"))
    created = models.DateTimeField(auto_now_add=True, verbose_name=_("Created"))
    updated = models.DateTimeField(auto_now=True, verbose_name=_("Updated"))
    image = models.ImageField(blank=True, null=True, verbose_name=_("Image"))


def determine_message_file(instance, filename):
    low = min([instance.sender.id, instance.receiver.id])
    high = max([instance.sender.id, instance.receiver.id])
    return f"messages/{low}_{high}/{filename}"


class Messages(models.Model):
    sender = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True,
                               related_name='messages_from_me', verbose_name=_("Sender"))
    receiver = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True,
                                 related_name='messages_to_me', verbose_name=_("Receiver"))
    message = models.TextField(max_length=140, verbose_name=_("Message"))
    created = models.DateTimeField(auto_now_add=True, verbose_name=_("Created"))
    seen = models.DateTimeField(blank=True, null=True, verbose_name=_("Seen"))
    file = models.FileField(blank=True, null=True,  upload_to='user_message_files/', verbose_name=_("File"))

communication/forms.py
from django import forms
from django.utils.translation import gettext_lazy as _


class MessageForm(forms.Form):
    message = forms.CharField(max_length=140, label=_("Message"))
    file = forms.FileField(required=False, label=_("File"))

communication/views.py
from django.db.models import Q
from django.urls import reverse,reverse_lazy
from django.utils import timezone

from communication.forms import MessageForm
from communication.models import Messages
from django.views.generic import ListView, DetailView, RedirectView, FormView

from django.contrib.auth import get_user_model
User = get_user_model()

class MessagesListView(ListView):
    model = Messages
    context_object_name = 'message_list'
    template_name = "communication/messages_list.html"

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super().get_context_data(object_list=object_list, **kwargs)
        qs =  Messages.objects.filter(receiver=self.request.user).values_list("sender",flat=True).distinct().annotate()
        o = User.objects.filter(pk__in=qs)  
        context = {'senders': o}
        return context
         
class MessagesDetailView(ListView):
    model = Messages
    template_name = "communication/messages_detail.html"
    
    def get_queryset(self):
        super().get_queryset().filter(
            Q(sender_id=self.kwargs["user_id"], receiver=self.request.user) & Q(seen__isnull=True)
        ).update(seen=timezone.now())
        query =super().get_queryset().filter(
            Q(sender_id=self.kwargs["user_id"], receiver=self.request.user) |
            Q(receiver_id=self.kwargs["user_id"], sender=self.request.user)
        ).order_by("created")
        total = query.count()
        limit = 50
        offset = total - limit if total - limit > 0 else 0
        return query[offset:]

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super().get_context_data(object_list=object_list, **kwargs)
        context["other_user"] = User.objects.get(id=self.kwargs["user_id"])
        context["form"] = MessageForm()
        return context


class MessagesSendView(FormView):
    form_class = MessageForm
    template_name="communication/send_message.html"
    
    def get_success_url(self):
        return reverse_lazy("communication:messages_detail", kwargs={"user_id": self.kwargs["user_id"]})
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["user_id"] = self.kwargs["user_id"]
        return context
    
    def form_valid(self, form):
        Messages.objects.create(
            sender=self.request.user,
            receiver_id=self.kwargs["user_id"],
            message=form.cleaned_data["message"],
            file=form.cleaned_data["file"]
        )
        return super().form_valid(form)

templates/communication/messages_detail.html
{% extends "base.html" %}
{% block body %}
<div class="container">
    <div style="width: 40%; text-align: center;" id="message_area" >
        <ul class="list-group">
        {% for object in object_list %}
        <li class="list-group-item
                            {% if object.sender == request.user %}
                             text-right
                            {% else %}
                            text-left
                            {% endif %}
                            ">
            {% if object.sender == request.user %}
            {% if object.file %}
            <a href="{{ object.file.url }}" class="badge badge-secondary">
            </a>
            {% endif %}
            {{ object.message }}
            <span class="badge badge-pill badge-info">
            {{ object.sender.username }}
            </span>
            {% else %}
            <span class="badge badge-pill badge-success">
            {{ object.sender.username }}
            </span>
            {{ object.message }}
            {% if object.file %}
            <a href="{{ object.file.url }}" class="badge badge-secondary">
            </a>
            {% endif %}
            {% endif %}
        </li>
        {% endfor %}
        </ul>
        
        <form method="POST" action="{% url 'communication:messages_send' user_id=other_user.id %}" class="form-group" style="margin-top: 5%;" enctype="multipart/form-data">
            {% csrf_token %}
            <input class="form-control" type="text" name="message" id="message" placeholder="Mesajınız">
            <button class="btn btn-primary" type="submit" >Gönder</button>
        </form>
    </div>
</div>
{% endblock %}

templates/communication/messages_list.html
{% extends "base.html" %}
{% block static %}
<script>
    $(".chat_ib").click(function () {
        window.location = $(this).find("a").attr("href");
        return false;
    });
</script>
{% endblock %}
{% block body %}
<div class="container">
    <h3 class=" margin-left">Messaging</h3>
    <div class="messaging">
        <div class="inbox_msg">
            <div class="inbox_people">

                <div class="inbox_chat">
                    {% for sender in  senders%}
                    <div class="chat_list active_chat">
                        <a href="/communication/detail/{{sender.id}}">
                            <div class="chat_people">
                                <div class="chat_img"> <img src="{{sender.profile_picture.url}}" alt="sunil"> </div>
                                <div class="chat_ib">

                                    <h5>{{sender.username}}
                                        <span class="chat_date">{{sender.last_login}}</span></h5>
                                </div>
                            </div>
                    </div>
                    </a>
                    {% endfor %}

                </div>
            </div>
        </div>
    </div>
</div>

{% endblock %}

templates/communication/send_message.html
{% extends "base.html" %}

{% block title %}Create an Account{% endblock %}
{% load crispy_forms_tags %}

{% block body %}
{% if request.user.id != user_id %}

<form method="POST" class="form-group" style="margin-top: 5%;" enctype="multipart/form-data">
	{% csrf_token %}
	<div class="row justify-content-center">
		<div class="col-6">
			{{ form|crispy }}
			<div class="col text-center">
				<button type="submit" class="btn btn-success">Gönder</button>
			</div>
		</div>
	</div>
</form>
{% else %}
	<h1>Kendinize mesaj gönderemezsiniz.</h1>
	{% block static %}
	
		<script>
				setTimeout(function () {
					window.location.href =  "/"
				}, 1500)
		</script>
	{% endblock %}
{% endif %}
{% endblock %}